diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/post.c tin-2.6.5/src/post.c
--- tin-2.6.4/src/post.c	2024-12-22 18:22:18.000000000 +0100
+++ tin-2.6.5/src/post.c	2025-12-08 20:32:45.691392557 +0100
@@ -2829,24 +2887,26 @@ check_moderated(
 		if (group->attribute->mailing_list && *group->attribute->mailing_list)
 			*art_type = GROUP_TYPE_MAIL;
 
-		if (!can_post && *art_type == GROUP_TYPE_NEWS) {
-			info_message(_(txt_cannot_post));
-			return NULL;
-		}
+		if (*art_type == GROUP_TYPE_NEWS) {
+			if (!can_post) {
+				info_message(_(txt_cannot_post));
+				return NULL;
+			}
 
-		if (group->moderated == 'x' || group->moderated == 'n' || group->moderated == 'j') {
-			error_message(2, _(txt_cannot_post_group), group->name);
-			return NULL;
-		}
+			if (group->moderated == 'x' || group->moderated == 'n' || group->moderated == 'j') {
+				error_message(2, _(txt_cannot_post_group), group->name);
+				return NULL;
+			}
 
-		if (group->moderated == 'm') {
-			char *prompt = fmt_string(_(txt_group_is_moderated), groupname);
-			if (prompt_yn(prompt, TRUE) != 1) {
-				error_message(*failmsg ? 2 : 0, failmsg);
+			if (group->moderated == 'm') {
+				char *prompt = fmt_string(_(txt_group_is_moderated), groupname);
+				if (prompt_yn(prompt, TRUE) != 1) {
+					error_message(*failmsg ? 2 : 0, failmsg);
+					free(prompt);
+					return NULL;
+				}
 				free(prompt);
-				return NULL;
 			}
-			free(prompt);
 		}
 	} while ((groupname = strtok(NULL, ",")) != NULL);
 
@@ -2899,13 +2959,13 @@ create_normal_article_headers(
 #	endif /* HAVE_CHMOD */
 #endif /* HAVE_FCHMOD */
 
-	get_from_name(from_name, group);
 #ifdef FORGERY
 	if ((tmp2 = make_path_header())) {
 		msg_add_header("Path", tmp2);
 		free(tmp2);
 	}
 #endif /* FORGERY */
+	get_from_name(from_name, sizeof(from_name), group);
 	msg_add_header("From", from_name);
 	msg_add_header("Subject", tinrc.default_post_subject);
 
@@ -2931,8 +2991,11 @@ create_normal_article_headers(
 	if (group->attribute->organization && *group->attribute->organization)
 		msg_add_header("Organization", random_organization(*group->attribute->organization));
 
-	if (*my_distribution && art_type == GROUP_TYPE_NEWS)
-		msg_add_header("Distribution", my_distribution);
+	if (art_type == GROUP_TYPE_NEWS) {
+		if ((tmp2 = find_distribution(newsgroups)) != NULL && *tmp2)
+			msg_add_header("Distribution", tmp2);
+		FreeIfNeeded(tmp2);
+	}
 
 	msg_add_header("Summary", "");
 	msg_add_header("Keywords", "");
@@ -2973,7 +3036,6 @@ quick_post_article(
 	 * second param is whether to assume yes to all which is the same as
 	 * the command line switch.
 	 */
-
 	if (pickup_postponed_articles(!postponed_only, postponed_only) || postponed_only)
 		return;
 
@@ -3027,7 +3089,7 @@ post_postponed_article(
 		char *ng = my_strdup(newsgroups);
 		char *p;
 		char buf[LEN];
-		unsigned int offset = 1;
+		int offset = 1;
 
 		if ((p = strchr(ng, ',')) != NULL)
 			*p = '\0';
@@ -3062,7 +3124,7 @@ count_postponed_articles(
 	if (!fp)
 		return 0;
 
-	while (fgets(line, (int) sizeof(line), fp)) {
+	while (fgets(line, sizeof(line), fp)) {
 		if (STRNCMPEQ(line, "From ", 5))
 			++count;
 	}
@@ -3115,7 +3177,7 @@ fetch_postponed_article(
 		return FALSE;
 	}
 
-	if (fgets(line, (int) sizeof(line), in) == NULL || strncmp(line, "From ", 5) != 0) {
+	if (fgets(line, sizeof(line), in) == NULL || strncmp(line, "From ", 5) != 0) {
 		fclose(in);
 		fclose(out);
 		fclose(tmp);
@@ -3134,7 +3196,7 @@ fetch_postponed_article(
 	 * line containing "From "
 	 */
 
-	while (fgets(line, (int) sizeof(line), in) != NULL) {
+	while (fgets(line, sizeof(line), in) != NULL) {
 		if (STRNCMPEQ(line, "From ", 5))
 			first_article = FALSE;
 		if (first_article) {
@@ -3206,7 +3268,7 @@ pickup_postponed_articles(
 		return FALSE;
 	}
 
-	snprintf(question, sizeof(question), _(txt_prompt_see_postponed), count);
+	snprintf(question, sizeof(question), P_(txt_prompt_see_postponed_sp[0], txt_prompt_see_postponed_sp[1], count), count);
 
 	if (ask && prompt_yn(question, TRUE) != 1)
 		return FALSE;
@@ -3401,9 +3463,10 @@ is_crosspost(
 {
 	int count = 0;
 
-	for (; *xref; xref++)
+	for (; *xref; xref++) {
 		if (*xref == ':')
 			++count;
+	}
 
 	return (count >= 2) ? TRUE : FALSE;
 }
@@ -3471,8 +3534,11 @@ join_references(
 			++e;	/* message-ids */
 			continue;
 		}
-		if (damaged_id(e)) {	/* remove damaged message ids and mark
-					   the gap if that's not already done */
+		if (damaged_id(e)) {
+			/*
+			 * remove damaged message ids and mark
+			 * the gap if that's not already done
+			 */
 			e += skip_id(e);
 			while (space < 3) {
 				++space;
@@ -3648,7 +3714,7 @@ post_response(
 	} else if (note_h.followup && strcmp(note_h.followup, groupname) != 0
 			&& strcmp(note_h.followup, note_h.newsgroups) != 0) {
 		char keyignore[MAXKEYLEN], keypost[MAXKEYLEN], keyquit[MAXKEYLEN];
-		int save_signal_context = signal_context;
+		enum context save_signal_context = signal_context;
 
 		show_followup_info();
 		signal_context = cPostFup;
@@ -3686,14 +3752,14 @@ post_response(
 #	endif /* HAVE_CHMOD */
 #endif /* HAVE_FCHMOD */
 
-	group = group_find(groupname, FALSE);
-	get_from_name(from_name, group);
 #ifdef FORGERY
 	if ((p = make_path_header())) {
 		msg_add_header("Path", p);
 		free(p);
 	}
 #endif /* FORGERY */
+	group = group_find(groupname, FALSE);
+	get_from_name(from_name, sizeof(from_name), group);
 	msg_add_header("From", from_name);
 
 	{
@@ -3708,7 +3774,7 @@ post_response(
 		len = (size_t) n + 1;
 		dbuf = my_malloc(len);
 		snprintf(dbuf, len, "Re: %s", tbuf);
-		free(ptr);
+		FreeAndNull(ptr);
 		msg_add_header("Subject", dbuf);
 		free(dbuf);
 	}
@@ -3721,6 +3787,28 @@ post_response(
 			msg_add_header("Followup-To", (strchr(note_h.followup, ',') != NULL) ? note_h.followup : "");
 	} else {
 		if (group && group->attribute->mailing_list && *group->attribute->mailing_list) {
+			/*
+			 * debian bug #250317 ->
+			 * TODO: loop over split_mailbox_list(note_h.to)
+			 *       as note_h.to and/or *group->attribute->mailing_list
+			 *       could hold multiple addresses
+			 */
+			if (note_h.to && *note_h.to && !address_in_list(note_h.to, *group->attribute->mailing_list))
+				ptr = append_to_string(ptr, note_h.to);
+			if (note_h.cc && *note_h.cc && !address_in_list(note_h.cc, *group->attribute->mailing_list)) {
+				if (ptr && *ptr)
+					ptr = append_to_string(ptr, ",");
+				ptr = append_to_string(ptr, note_h.cc);
+			}
+			if (ptr && *ptr) {
+				msg_add_header("Cc", ptr);
+				free(ptr);
+			}
+
+			if (note_h.bcc && *note_h.bcc && !address_in_list(note_h.bcc, *group->attribute->mailing_list))
+				msg_add_header("Bcc", note_h.bcc);
+			/* <- debian bug #250317 */
+
 			msg_add_header("To", *group->attribute->mailing_list);
 			art_type = GROUP_TYPE_MAIL;
 		} else {
@@ -3757,8 +3845,13 @@ post_response(
 		ADD_MSG_ID_HEADER();
 		if (note_h.distrib)
 			msg_add_header("Distribution", note_h.distrib);
-		else if (*my_distribution)
-			msg_add_header("Distribution", my_distribution);
+		else {
+			char *d = find_distribution((note_h.followup && use_followup_to) ? note_h.followup : note_h.newsgroups);
+
+			if (d && *d)
+				msg_add_header("Distribution", d);
+			FreeIfNeeded(d);
+		}
 	}
 
 	if (group)
@@ -3790,7 +3883,7 @@ post_response(
 
 		if (raw_data) { /* rewind raw article if needed */
 			if (fseek(pgart.raw, 0L, SEEK_SET) == -1) {
-				perror_message(txt_error_fseek, pgart.raw);
+				perror_message(txt_error_fseek);
 				goto pout;
 			}
 		}
@@ -3802,7 +3895,7 @@ post_response(
 				char buffer[8192];
 
 				/* skip headers + header/body separator */
-				while (fgets(buffer, (int) sizeof(buffer), pgart.raw) != NULL) {
+				while (fgets(buffer, sizeof(buffer), pgart.raw) != NULL) {
 					offset = (long) ((size_t) offset + strlen(buffer));
 					if (buffer[0] == '\n' || buffer[0] == '\r')
 						break;
@@ -3828,7 +3921,7 @@ post_response(
 					 * cooking 'hides' all other headers
 					 */
 					if (fseek(pgart.cooked, 0L, SEEK_SET) == -1) { /* rewind cooked art */
-						perror_message(txt_error_fseek, pgart.cooked);
+						perror_message(txt_error_fseek);
 						goto pout;
 					}
 				} else { /* without headers */
@@ -3841,7 +3934,7 @@ post_response(
 						++i;
 
 					if (fseek(pgart.cooked, pgart.cookl[i].offset, SEEK_SET) == -1) { /* skip headers and header/body separator */
-						perror_message(txt_error_fseek, pgart.cooked);
+						perror_message(txt_error_fseek);
 						goto pout;
 					}
 				}
@@ -3903,18 +3996,10 @@ create_mail_headers(
 		char from_buf[HEADER_LEN];
 		char *from_address;
 
-		if (curr_group && curr_group->attribute && curr_group->attribute->from && *curr_group->attribute->from)
-			from_address = *curr_group->attribute->from;
-		else /* i.e. called from select.c without any groups */
-			from_address = tinrc.mail_address;
-
-		if (from_address == NULL || !*from_address) {
-			get_from_name(from_buf, (struct t_group *) 0);
-			from_address = &from_buf[0];
-		} /* from_address is now always a valid pointer to a string */
+		get_from_name(from_buf, sizeof(from_buf), (struct t_group *) 0);
+		from_address = &from_buf[0];
 
-		if (*from_address)
-			msg_add_header("From", from_address);
+		msg_add_header("From", from_address);
 
 		msg_add_header("To", to);
 		msg_add_header("Subject", subject);
@@ -3929,12 +4014,12 @@ create_mail_headers(
 		 * only for displaying; the MTA has to deal with it. They shouldn't be
 		 * put in the file in the first place, so we don't do it.
 		 */
-		if (!address_in_list(to, strlen(from_address) ? from_address : userid)) {
+		if (!address_in_list(to, from_address)) {
 			if ((curr_group && curr_group->attribute && (curr_group->attribute->auto_cc_bcc & AUTO_CC)) || (!curr_group && (tinrc.auto_cc_bcc & AUTO_CC)))
-				msg_add_header("Cc", strlen(from_address) ? from_address : userid);
+				msg_add_header("Cc", from_address);
 
 			if ((curr_group && curr_group->attribute && (curr_group->attribute->auto_cc_bcc & AUTO_BCC)) || (!curr_group && (tinrc.auto_cc_bcc & AUTO_BCC)))
-				msg_add_header("Bcc", strlen(from_address) ? from_address : userid);
+				msg_add_header("Bcc", from_address);
 		}
 
 		if (curr_group && curr_group->attribute && curr_group->attribute->fcc && strlen(*curr_group->attribute->fcc))
@@ -4099,7 +4184,7 @@ mail_loop(
 					}
 
 					if (confirm && submit_mail_file(filename, group, articlefp, is_changed)) {
-						info_message(_(txt_articles_mailed), 1, _(txt_article_singular));
+						info_message(_(txt_article_mailed_sp[1]), 1, _(txt_article_sp[0]));
 						return POSTED_OK;
 					}
 				}
@@ -4184,7 +4269,7 @@ mail_to_someone(
 
 	if (!mime_forward || tinrc.interactive_mailer != INTERACTIVE_NONE) {
 		if (fseek(artinfo->raw, 0L, SEEK_SET) == -1) {
-			perror_message(txt_error_fseek, artinfo->raw);
+			perror_message(txt_error_fseek);
 			fclose(fp);
 			return ret_code;
 		}
@@ -4300,7 +4385,7 @@ mail_bug_report(
 		DEFAULT_ARTICLE_NUM,
 		tinrc.reread_active_file_secs,
 		BlankIfNull(nntp_caps.over_cmd));
-	fprintf(fp, "CFG2 : debug=%d, threading=%d\n", debug, tinrc.thread_articles);
+	fprintf(fp, "CFG2 : debug=%u, threading=%d\n", debug, tinrc.thread_articles);
 	fprintf(fp, "CFG3 : domain=[%s]\n", BlankIfNull(domain));
 	start_line_offset += 4;
 
@@ -4318,6 +4403,10 @@ mail_bug_report(
 			fprintf(fp, "IMPLE: %s\n", nntp_caps.implementation);
 			++start_line_offset;
 		}
+		if (*serverrc.disabled_nntp_cmds) {
+			fprintf(fp, "-CMDS: %s\n", serverrc.disabled_nntp_cmds);
+			++start_line_offset;
+		}
 	}
 #endif /* NNTP_ABLE */
 
@@ -4438,7 +4527,7 @@ mail_to_author(
 
 		if (raw_data) {/* rewind raw article if needed */
 			if (fseek(pgart.raw, 0L, SEEK_SET) == -1) {
-				perror_message(txt_error_fseek, pgart.raw);
+				perror_message(txt_error_fseek);
 				goto mout;
 			}
 		}
@@ -4450,7 +4539,7 @@ mail_to_author(
 				char buffer[8192];
 
 				/* skip headers + header/body separator */
-				while (fgets(buffer, (int) sizeof(buffer), pgart.raw) != NULL) {
+				while (fgets(buffer, sizeof(buffer), pgart.raw) != NULL) {
 					offset = (long) ((size_t) offset + strlen(buffer));
 					if (buffer[0] == '\n' || buffer[0] == '\r')
 						break;
@@ -4476,7 +4565,7 @@ mail_to_author(
 					 * cooking 'hides' all other headers
 					 */
 					if (fseek(pgart.cooked, 0L, SEEK_SET) == -1) {
-						perror_message(txt_error_fseek, pgart.cooked);
+						perror_message(txt_error_fseek);
 						goto mout;
 					}
 				} else { /* without headers */
@@ -4488,7 +4577,7 @@ mail_to_author(
 						++i;
 
 					if (fseek(pgart.cooked, pgart.cookl[i].offset, SEEK_SET) == -1) {
-						perror_message(txt_error_fseek, pgart.cooked);
+						perror_message(txt_error_fseek);
 						goto mout;
 					}
 				}
@@ -4639,7 +4728,7 @@ cancel_article(
 		grp_del_mail_art(art);
 		return FALSE;
 	}
-	get_from_name(from_name, group); /* TODO: strip_name() for both? */
+	get_from_name(from_name, sizeof(from_name), group); /* TODO: strip_name() for both? */
 
 #ifdef DEBUG
 	if (debug & DEBUG_MISC)
@@ -4754,8 +4843,13 @@ cancel_article(
 
 	if (note_h.distrib)
 		msg_add_header("Distribution", note_h.distrib);
-	else if (*my_distribution)
-		msg_add_header("Distribution", my_distribution);
+	else {
+		char *d = find_distribution(note_h.newsgroups);
+
+		if (d && *d)
+			msg_add_header("Distribution", d);
+		FreeIfNeeded(d);
+	}
 
 	/* some ppl. like X-Headers: in cancels */
 	msg_add_x_headers(group->attribute->x_headers);
@@ -4804,7 +4898,7 @@ cancel_article(
 			char *smsg;
 			char buff[LEN];
 			char keycancel[MAXKEYLEN], keyedit[MAXKEYLEN], keyquit[MAXKEYLEN];
-			int save_signal_context = signal_context;
+			enum context save_signal_context = signal_context;
 
 			snprintf(buff, sizeof(buff), _(txt_quit_cancel),
 					PrintFuncKey(keyedit, POST_EDIT, post_cancel_keys),
@@ -4932,7 +5026,7 @@ repost_article(
 #	endif /* HAVE_CHMOD */
 #endif /* HAVE_FCHMOD */
 
-	get_from_name(from_name, group);
+	get_from_name(from_name, sizeof(from_name), group);
 
 	if (Superseding) {
 #ifdef FORGERY
@@ -5004,9 +5098,13 @@ repost_article(
 		if (*reply_to)
 			msg_add_header("Reply-To", reply_to);
 
-		if (*my_distribution)
-			msg_add_header("Distribution", my_distribution);
+		if (!group->attribute->mailing_list || !*group->attribute->mailing_list) {
+			char *d = find_distribution(groupname);
 
+			if (d && *d)
+				msg_add_header("Distribution", d);
+			FreeIfNeeded(d);
+		}
 	} else {
 		if (note_h.org)
 			msg_add_header("Organization", note_h.org);
@@ -5032,7 +5130,7 @@ repost_article(
 		 * all string lengths are calculated to a maximum line length
 		 * of 76 characters, this should look ok (sven@tin.org)
 		 *
-		 * TODO : use strunc() on note_h.subj?
+		 * TODO: use strunc() on note_h.subj?
 		 */
 		fprintf(fp, "[ %-*s ]\n", (int) (72 + strlen(_(txt_article_reposted)) - (size_t) strwidth(_(txt_article_reposted))), _(txt_article_reposted));
 		fprintf(fp, "[ From: %-*s ]\n", (int) (66 + strlen(note_h.from) - (size_t) strwidth(note_h.from)), note_h.from);
@@ -5193,7 +5291,7 @@ msg_add_x_headers(
 				return;
 		}
 
-		while (fgets(line, (int) sizeof(line), fp) != NULL) {
+		while (fgets(line, sizeof(line), fp) != NULL) {
 			if (line[0] != '\n' && line[0] != '#') {
 				if (line[0] != ' ' && line[0] != '\t') {
 					x_hdrs = my_realloc(x_hdrs, (size_t) (num_x_hdrs + 1) * sizeof(char *));
@@ -5201,6 +5299,7 @@ msg_add_x_headers(
 				} else {
 					if (!num_x_hdrs) /* folded line, but no previous header */
 						continue;
+
 					i = (int) strlen(x_hdrs[num_x_hdrs - 1]);
 					x_hdrs[num_x_hdrs - 1] = my_realloc(x_hdrs[num_x_hdrs - 1], (size_t) i + strlen(line) + 1);
 					strcpy(x_hdrs[num_x_hdrs - 1] + i, line);
@@ -5279,7 +5378,7 @@ msg_add_x_body(
 				return 0;
 		}
 
-		while (fgets(line, (int) sizeof(line), fp) != NULL) {
+		while (fgets(line, sizeof(line), fp) != NULL) {
 			fputs(line, fp_out);
 			++wrote;
 		}
@@ -5364,7 +5463,7 @@ checknadd_headers(
 
 	if ((group && group->attribute->advertising) || (!group && tinrc.advertising)) {	/* Add after other headers */
 		char *suffix = NULL;
-		size_t len;
+		size_t len = 0;
 
 #if defined(HAVE_SYS_UTSNAME_H) && defined(HAVE_UNAME)
 		if (*system_info.release) {
@@ -5402,7 +5501,6 @@ checknadd_headers(
 			PRODUCT, VERSION, RELEASEDATE, RELEASENAME, BlankIfNull(suffix));
 		FreeIfNeeded(suffix);
 	}
-
 	fputs("\n", fp_out); /* header/body separator */
 
 	while ((l = tin_fgets(fp_in, FALSE)) != NULL)
@@ -5434,10 +5532,7 @@ insert_from_header(
 	snprintf(outfile, sizeof(outfile), "%s.%ld", infile, (long) process_id);
 	if ((fp_out = fopen(outfile, "w")) != NULL) {
 		strcpy(from_name, "From: ");
-		if (tinrc.mail_address && *tinrc.mail_address) { /* FIXME: avoid hardcoded length */
-			snprintf(from_name + 6, sizeof(from_name) - 7, "%.1016s", tinrc.mail_address);
-		} else
-			get_from_name(from_name + 6, (struct t_group *) 0);
+		get_from_name(from_name + 6, sizeof(from_name) - 6, (struct t_group *) 0);
 
 #	ifdef DEBUG
 		if (debug & DEBUG_MISC)
@@ -5522,7 +5617,7 @@ static void
 find_reply_to_addr(
 	char *from_addr,
 	t_bool parse,
-	struct t_header *hdr)
+	const struct t_header *hdr)
 {
 	const char *ptr;
 
@@ -5616,7 +5711,8 @@ static void
 update_active_after_posting(
 	char *newsgroups)
 {
-	char *src, *dst;
+	char *dst;
+	const char *src;
 	char groupname[HEADER_LEN] = { '\0' };
 	struct t_group *group;
 
@@ -5997,9 +6093,11 @@ get_recipients(
 	for (i = 0; i < (num_all - 1); i++) {
 		if (!all_addresses[i])
 			continue;
+
 		for (j = i + 1; j < num_all; j++) {
 			if (!all_addresses[j])
 				continue;
+
 			if (!strcasecmp(all_addresses[i], all_addresses[j]))
 				FreeAndNull(all_addresses[j]);
 		}
@@ -6051,7 +6149,7 @@ build_messageid(
 	int i;
 	size_t j;
 	static char buf[NNTP_STRLEN]; /* Message-IDs are limited to 250 octets as of RFC 5536 3.1.3 and RFC 3977 3.6 */
-	static unsigned long int seqnum = 0; /* use a counter in tinrc? */
+	static unsigned long int seqnum = 0L; /* use a counter in tinrc? */
 	time_t t = time(NULL);
 
 	if (t >= 1041379200) /* 2003-01-01 00:00:00 GMT */
@@ -6063,6 +6161,7 @@ build_messageid(
 	strcat(buf, radix32(t));
 	strcat(buf, "I");
 	strcat(buf, radix32((unsigned long) process_id));
+	i = strlen(buf);
 
 #	ifndef FORGERY
 	{
@@ -6074,10 +6173,10 @@ build_messageid(
 		static char buf2[HEADER_LEN];
 
 		strip_name(build_sender(), buf2);
-		if (strlen(buf) + strlen(buf2) + strlen(radix32(getuid())) + 2 > sizeof(buf) - 1)
+		if (i + strlen(buf2) + strlen(radix32(getuid())) + 2 > sizeof(buf) - 1)
 			return NULL;
 
-		snprintf(buf + strlen(buf), sizeof(buf) - strlen(buf), "N%s%%%s>", radix32(getuid()), buf2);
+		snprintf(buf + i, sizeof(buf) - i, "N%s%%%s>", radix32(getuid()), buf2);
 	}
 #	else
 	/*
@@ -6085,7 +6184,7 @@ build_messageid(
 	 * draft-ietf-usefor-msg-id-alt-00, 2.1.1
 	 * based on the host's FQDN
 	 */
-	snprintf(buf + strlen(buf), sizeof(buf) - strlen(buf), "N%s@%s>", radix32(getuid()), get_fqdn(get_host_name()));
+	snprintf(buf + i, sizeof(buf) - i, "N%s@%s>", radix32(getuid()), BlankIfNull(get_fqdn(get_host_name())));
 #	endif /* !FORGERY */
 
 	/*
@@ -6284,7 +6383,7 @@ add_headers(
 
 				if (adddate) {
 					time_t epoch;
-					char dateheader[50];
+					char dateheader[50] = { '\0' };
 #if defined(HAVE_SETLOCALE) && !defined(NO_LOCALE)
 					char *old_lc_all = NULL, *old_lc_time = NULL;
 
@@ -6352,10 +6451,7 @@ add_headers(
 			break;
 		}
 	}
-#ifdef HAVE_FSYNC
-	fsync(fd_out);
-#endif /* HAVE_FSYNC */
-	close(fd_out);
+	sync_close(fd_out);
 	fclose(fp_in);
 	if (writesuccess)
 		rename_file(outfile, infile);
@@ -6422,8 +6518,8 @@ stripped_double_ngs(
 	char **newsgroups,
 	int *ngcnt)
 {
-	char *that_group;
-	char *this_group;
+	const char *that_group;
+	const char *this_group;
 	unsigned int i = 0;
 	unsigned int j;
 	unsigned int k;
@@ -6458,7 +6554,7 @@ strip_double_ngs(
 	char **newsgroups;
 	int ngcnt;
 
-	if (strchr(ngs_list, ',') == NULL)	/* shortcut, only one newsgroup */
+	if (!ngs_list || strchr(ngs_list, ',') == NULL)	/* shortcut, only one newsgroup */
 		return;
 
 	if ((newsgroups = build_nglist(ngs_list, &ngcnt)) == NULL) /* something went wrong */
@@ -6466,7 +6562,7 @@ strip_double_ngs(
 
 	if (stripped_double_ngs(newsgroups, &ngcnt)) {
 		/* something has changed, rebuild newsgroups list */
-		char *this_group;
+		const char *this_group;
 		unsigned int i = 0;
 
 		this_group = newsgroups[i++];
@@ -6479,3 +6575,60 @@ strip_double_ngs(
 	free(*newsgroups);
 	free(newsgroups);
 }
+
+
+static char *
+find_distribution(
+	const char *ngs_list)
+{
+	char *distributions = NULL;
+	int w;
+
+	if (*my_distribution) {
+		distributions = append_to_string(distributions, my_distribution);
+#if 0 /* this is what the mapages says */
+		return distributions;
+#else  /* and this is likely the better solution */
+		distributions = append_to_string(distributions, ",");
+#endif /* 0 */
+	}
+
+#ifdef NNTP_ABLE
+	{
+		char *cg, *ng, *ngcpy, *d = NULL;
+		t_distrib_pat *p, *q;
+
+		/* TODO: what if x-post and contradicting distributions? */
+		ng = ngcpy = my_strdup(ngs_list);
+		w = INT_MIN;
+		while ((cg = strtok(ng, ",")) != NULL) {
+			for (p = nntp_caps.distrib_pats; p != NULL; p = q) {
+				q = p->next;
+				if (!p->pattern)
+					continue;
+				if (match_group_list(cg, p->pattern)) {
+					if (!d || (*d && p->weight > w)) {
+						w = p->weight;
+						d = p->distribution;
+					}
+				}
+			}
+			if (d && *d) {
+				distributions = append_to_string(distributions, d);
+				distributions = append_to_string(distributions, ",");
+				d = NULL;
+			}
+			ng = NULL;
+		}
+		free(ngcpy);
+	}
+#endif /* NNTP_ABLE */
+
+	if (distributions && *distributions) {
+		strip_double_ngs(distributions);
+		w = strlen(distributions);
+		if (w && distributions[w - 1] == ',')
+			distributions[w - 1] = '\0';
+	}
+	return distributions;
+}
